# LICA_1.0.0
LICA is Lithion-ion cluster analysis code. It is a python wrapped c++ code to analyze trajectories of any particular atom from molecular dynamics simulations in many popular formats.

Features: 

- Allows for efficient and fast calculations on millions of atoms, each with many freely defined per-atom properties.
- Mean square displacement calculation [xyz, xy, xz, yz, x, x, y, z].
- Plot and save calculated properties in many popular format [pdf, png]
- Neighbour list analysis of any atoms  
- Built-in unit conversions
- The pakage is still under development

## Installation Requirements:
It is supposed that lica is installed on the recent linux distribution like Ubuntu or Fedora with Python version 3.9 or later. It is recomended that users use conda (conda-forge channel) packages. Windows users should use conda (conda-forge channel) packages as well.

- g++
- Python (>=3.9) 
- numpy (>=1.15)
- matplotlib (>=2.2.2)
- python-yaml (pyyaml)
- mdanalysis (https://www.mdanalysis.org/)

It is recommended to use anaconda.

### Installation Example:
- step 1 : install anaconda 
- step 2 : prepare virtual envirnmnet by using the command [ conda create -n py3,9 python=3.9 ]
- step 3 : activate virtual environmant by using the command [ conda activate py3.9 ]
- step 4 : install mdanalysis by using the command [ conda install -c conda-forge  MDAnalysis ]
- step 5 : download LICA_BCAM_1.0.0
- step 6 : unzip LICA_BCAM_1.0.0.zip
- step 7 : cd LICA_BCAM_1.0.0
- step 8 : use the command [ CC=g++ python setup.py install ]

## How to use LICA
After installation use following commands
- lica --run [It will create INFO file. Edit the file with necessary information and run again the same command]
- lica --run [Read the information printated on the screen]

## Authors and acknowledgment
- Dr. Pinku Nath, BCAM - Basque Center for Applied Mathematics, Spain
- Dr. Henry Andres Cortes, BCAM - Basque Center for Applied Mathematics, Spain
- Dr. Mauricio Rincon Bonilla, BCAM - Basque Center for Applied Mathematics, Spain
- Prof. Elena Akhmatskaya, BCAM - Basque Center for Applied Mathematics, Spain


