#include <iostream>
#include <fstream>
#include <vector>
#include <iterator>
#include <stdint.h>
#include <sstream>
#include <algorithm> 
#include <numeric>      // std::iota
using namespace std;


namespace anastd 
{
	 //extern ofstream _logfile;
     typedef vector<uint> UVEC;
     typedef vector<UVEC> UMAT;
     typedef vector<int> IVEC;
     typedef vector<IVEC> IMAT;
     typedef vector<double> DVEC;
     typedef vector<DVEC> DMAT;
     typedef vector<DMAT> DTEN1;
     typedef vector<string> SVEC;
     typedef vector<SVEC> SMAT;
     template <typename T> vector<T> split(const std::string &line);
	 vector<vector<double> > readbinfile(const string filename);
	 UMAT get_vectot_w_index(UVEC & v);
/*
     template <typename T> T sum(const vector<T> &u)
      {
		T sumx= T();
		for(uint i=0; i<u.size(); i++)sumx+=u[i];
	    return sumx;
      }*/
     bool IsFileExist(const string filename);
	 bool is_number(const std::string& s);
	 bool isNumber(const string& s);
	 template <typename T>
		vector<T> split(const string &line) {
		istringstream is(line);
        return vector<T>(istream_iterator<T>(is), istream_iterator<T>());
  }
	template <typename T>
		vector<vector<T> > readFile(const string filename)
	{
		vector<vector<T> > M;
		ifstream infile (filename);
		if(!infile.is_open()){
			cerr <<"[ERROR] absent file: "+ filename << endl;
			exit(0);
		}
		string line;
		while ( getline (infile,line) ){
        if (line == "") continue;
        if (line[0] == '#') continue;
        if (line[0] == '!') continue;
			M.push_back(split<T>(line));
		}
		infile.clear();
		infile.close();
		if(M.size()==0){
			cerr <<"[ERROR] file reading fail: "+ filename << endl;
			exit(0);
		}
		return M;
	}
	template <typename T> bool gte(T a, T b)
	{
		if(abs(a-b)<0.0001)
		{
			return true;
		}else if (a>b){
			return true;
		}else return false;
	}
/*
	template <typename T>
		vector<size_t> sort_indexes(const vector<T> &v)
		{
			vector<size_t> idx(v.size());
			iota(idx.begin(), idx.end(), 0);

			stable_sort(idx.begin(), idx.end(),
			[&v](size_t i1, size_t i2) {return v[i1] < v[i2];});

		return idx;
		}
*/
/*
	template <typename T> vector<T> 
		get_column(vector<vector<T> > &m, uint index)
		{
			vector<T> v(m.size(), T{});
			for(uint i=0; i<m.size(); i++)
			{
				v[i] = m[i][index];
			}
			return v;
		}*/
	template <typename T>
		void clear_vec(vector<T> &v)
		{
			v.clear();
		}
	template <typename T>
		void clear_mat(vector<vector<T> > &m)
		{
			for(uint i=0; i<m.size(); i++)
			{
				m[i].clear();
			}
			m.clear();
		}
	template <typename T>
		void clear_vmat(vector<vector<vector<T> > > &vm)
		{
			for(uint i=0; i<vm.size(); i++)
			{
				for(uint j=0; j<vm[i].size(); j++)
				{
					vm[i][j].clear();
				}
				vm.clear();
			}
			vm.clear();
		}
/*
	template <typename T>
		vector<vector<vector<T> > > get_vmat(uint sizez, uint sizey, uint sizex)
		{
			vector<T> d1 (sizex, T{});
			vector<vector<T> > d2(sizey, d1);
			vector<vector<vector<T> > > d3 (sizez, d2);
			return d3;
		}
	template <typename T>
		vector<vector<T> > get_mat(uint sizey, uint sizex)
		{
			vector<T> d1 (sizex, T{});
			vector<vector<T> > d2(sizey, d1);
			return d2;
		}*/
}
