#include <Python.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <iterator>
#include <numeric>
#include <stdint.h>
#include <sstream>
#include <algorithm> 
#include <iomanip>
#include <math.h> 
#include <iomanip>
#include <memory>

//#include <numpy/arrayobject.h>

/*
#ifndef _ANASTD_H_
#define _ANASTD_H_
#include <anastd_header.h>
#endif
*/

#ifndef uint
#define uint unsigned int
#endif 

#define _LOG_MESSAGE_  "[LICA]"
#define _LOG_ERROR_MESSAGE_  "[ERROR_LICA]"

using namespace std;

typedef vector<uint> UVEC;
typedef vector<int> IVEC;
typedef vector<double> DVEC;
typedef vector<DVEC> DMAT;
typedef vector<IVEC> IMAT;
typedef vector<UVEC> UMAT;
typedef vector<DMAT> TEN1;
typedef vector<string> SVEC;
typedef vector<SVEC> SMAT;

class Logger{
   public:
       Logger();
      ~Logger();
       ofstream log;
      void close();
	  bool get_IO_name();
};
class gromax_info
{
	protected:
		Logger& _logger;
	public:
		gromax_info(Logger& _logger);
		~gromax_info();
		void clear();
		//bool get_IO_name(char *, char *);
		bool get_IO_name(char *);
		bool get_IO_name(char *, char *, char *);
		SVEC get_elements(){return _elements;}
		string get_poscar_name(){return _poscar_file;}
	private:
		string star;
		SVEC _elements;
		SVEC _elements_title;
		string _forcefield_name;
		string _dir;
		string _outdir;
		string _info_file;
		DMAT _lattice;
		DMAT _positions;
		SVEC _atom_types;
		IVEC _atom_num;
		SVEC _atom_types_sorted;
		IVEC _atom_indices;
		IVEC _atom_indices_sorted;
		string _poscar_file;
		double _time_step;
		double _dt;
		bool read_forcefield();
		bool read_info();
		bool organize_indices();
		bool write_poscar();
};
