import os
import sys
import lica.ana_std as ana
import yaml
import numpy as np
#import lica.gmax as GMAX
#from ovito.io import import_file, export_file
#from pymatgen.io.vasp import Poscar
#from phonopy.structure.atoms import PhonopyAtoms
#import aqha.plot as Plot

def create_dir():
	outdir = 'outdir'
	if os.path.isdir(outdir) is False:
		os.mkdir(outdir)
	return outdir

def read_replace():
	if ana.IsFileExist('replace.dat') is False:
		sys.stderr.write('[ERROR] replace.dat absent \n')
		return False

class FILE_INFO:
	def __init__(self):
		self.info = 'INFO'
		self.gromacs = True
		self.is_binary = True
		self.figure_extension = 0
		self.DIR = []
		self.forcefield_itp = []
		self.tpr = []
		self.trr = []
		self.start = 0
		self.stop = 0
		self.step = 0
		self.cutoff = 2.5
		self.center_atom = []
	def create_info(self):
		if ana.IsFileExist(self.info) is False:
			out = open(self.info, 'w')
			out.write('# : comment out lines \n')
			out.write('#gromacs : 1 (true)/0 (false) \n')
			out.write('#binary : 1 (true)/0 (false) \n')
			out.write('#figure_extension : 0 (pdf)/1(png)\n')
			out.write('#cutoff : 2.5 Angstrom (default value). It is the cutoff radius for neighbour list calculation.\n')
			out.write('gromacs : 1 \n')
			out.write('binary : 1 \n')
			out.write('figure_extension : 0 \n')
			out.write('path : /path_of_input_files\n')
			out.write('forcefield_file_name : forcefield.itp\n')
			out.write('tpr_file_name : nvt.tpr\n')
			out.write('trr_file_name : nvt.trr\n')
			out.write('start : 0\n')
			out.write('stop : 10\n')
			out.write('step : 1\n')
			out.write('cutoff : 2.5\n')
			out.write('center_atom : Li\n')
			out.close()
			sys.stderr.write('Edit '+self.info +' and run lica again\n')
			return False
		else:
			data_loaded = ana.read_yaml_data(self.info)
			self.gromacs = bool(data_loaded[0]['gromacs'])
			self.is_binary = bool(data_loaded[0]['binary'])
			self.figure_extension = bool(data_loaded[0]['figure_extension'])
			self.DIR = data_loaded[0]['path']
			self.forcefield_itp = self.DIR+'/'+data_loaded[0]['forcefield_file_name']
			self.tpr = self.DIR+'/'+data_loaded[0]['tpr_file_name']
			self.trr = self.DIR+'/'+data_loaded[0]['trr_file_name']
			self.start = int(data_loaded[0]['start'])
			self.stop = int(data_loaded[0]['stop'])
			self.step = int(data_loaded[0]['step'])
			self.cutoff = float(data_loaded[0]['cutoff'])
			self.center_atom = data_loaded[0]['center_atom']
			if(self.is_binary is True):
				if ana.IsFileExist(self.forcefield_itp) is False:
					sys.stderr.write('[ERROR] forcefield_itp file absent \n')
					return False
				if ana.IsFileExist(self.tpr) is False:
					sys.stderr.write('[ERROR] tpr file absent \n')
					return False
				if ana.IsFileExist(self.trr) is False:
					sys.stderr.write('[ERROR] trr file absent \n')
					return False
			return True
	def get_info(self):
		return self.info
	def get_gromacs(self):
		return self.gromacs
	def get_forcefield_itp(self):
		return self.forcefield_itp
	def get_is_binary(self):
		return self.is_binary
	def get_DIR(self):
		return self.DIR
	def get_tpr(self):
		return self.tpr
	def get_trr(self):
		return self.trr
	def get_start(self):
		return self.start
	def get_stop(self):
		return self.stop
	def get_step(self):
		return self.step
	def get_cutoff(self):
		return self.cutoff
	def get_center_atom(self):
		return self.center_atom
	def get_figure_extension(self):
		return self.figure_extension
