#ifndef _MAIN_H_
#define _MAIN_H_
#include <main_header.h>
#endif

#ifndef _ANASTD_H_
#define _ANASTD_H_
#include <anastd_header.h>
#endif
  
using namespace std;
using namespace anastd;
static PyObject *FileNotFoundError = NULL;

static PyObject *PyCppAPI_read_element_names(PyObject *self, PyObject *args)
{
    //char *dir = NULL;
    //char *outdir = NULL;
	char * forcefield_itp = NULL;
    //if(!PyArg_ParseTuple(args, "ss", &forcefield_itp, &outdir))
    if(!PyArg_ParseTuple(args, "s", &forcefield_itp))
    {
        return NULL;
    }
	Logger logger;
	gromax_info info(logger);
	//info.get_IO_name(forcefield_itp, outdir);
	info.get_IO_name(forcefield_itp);
	SVEC elements = info.get_elements();


	PyObject *PList = PyList_New(0);

	for(uint i =0 ; i< elements.size() ; i++ )
	{
		const char * ch = elements[i].c_str(); 

		PyList_Append(PList, Py_BuildValue("z", ch));
	}


	info.clear();
	return PList;
}
static PyObject *PyCppAPI_read_info_file(PyObject *self, PyObject *args)
{
    char *dir = NULL;
    char *outdir = NULL;
    char *info_file = NULL;

    if(!PyArg_ParseTuple(args, "sss", &dir, &outdir, &info_file))
    {
        return NULL;
    }
	Logger logger;

	gromax_info info(logger);

	info.get_IO_name(dir, outdir, info_file);
	string poscar = info.get_poscar_name();

	PyObject *PList = PyList_New(0);
	const char * ch = poscar.c_str(); 
	PyList_Append(PList, Py_BuildValue("z", ch));

	info.clear();

	return PList;
	//Py_RETURN_TRUE;
}
static PyMethodDef Py_Methods[] = {
    {"read_element_names",  PyCppAPI_read_element_names, METH_VARARGS, "forcefield reader"},
    {"read_info_file",  PyCppAPI_read_info_file, METH_VARARGS, "info_file reader"},
    {NULL, NULL, 0, NULL}
};

static struct PyModuleDef modules = {
    PyModuleDef_HEAD_INIT,
    "LICA",
    "Python interface for the LICA C library function",
    -1,
    Py_Methods
};

PyMODINIT_FUNC PyInit_LICA(void)
{
    PyObject *module = PyModule_Create(&modules);
    FileNotFoundError = PyErr_NewException("LICA.FileNotFoundError", NULL, NULL);
    PyModule_AddObject(module, "FileNotFoundError", FileNotFoundError);
    //return module;
    if(module==NULL) return NULL;
    //import_array();
    if (PyErr_Occurred()) return NULL;
    return module;
}
